<?php
// $Id: webmail_plus.view_threads.inc,v 1.1.2.1 2008/07/08 01:26:14 firmidea Exp $
function webmail_plus_view_threads_form() {
  global $user, $_webmail_plus_config, $_webmail_plus_connection;


  $mail_api_connection = webmail_plus_connect();
  $overview = mail_api_overview();

  $threads = array();

  $all_message_ids = array();

  foreach ($overview as $index => $header) {
    echo "processing $index\n";

    $raw = imapwu_api_header($header->msgno, $options);


    $references = webmail_plus_extract_references($raw);


    webmail_plus_dump($references);

    /*

    */

    // now group messages by ids into threads



    // walk thru all the treads see if an id is there
    /*
    foreach($threads as $thread_id=>$message_ids) {

    }
    */

  }



}

/*
 * takes a message header as a string and returns an array
 */
function webmail_plus_parse_header($header, $lowercase=FALSE) {

  $lines = explode("\n", $header);

  foreach($lines as $id=>$line) {

    // skip empty lines
    if(trim($line)=="") continue;


    if(preg_match("/\t/", $line)) {
      //echo "tab found\n";
      $rs[$key] .= "\n".trim($line);
      continue;
    }



    list($key,$value) = split(":", $line, 2);
    $key=trim($key);

    if($lowercase) $key=strtolower($key);

    // do not add anything if the key is blank
    if($key=="") continue;

    $rs[$key]=trim($value);
  }

  return $rs;
}

function webmail_plus_add_message_to_thread($message_id_1, $message_id_2) {
  global $user;
  if ($user->uid<=0) return FALSE;

  if ($message_id_1=="" || $message_id_2=="") return FALSE;
}

/**
 * takes a header array and extracts all references
 *
 * @param unknown_type $header
 * @return unknown
 */
function webmail_plus_extract_references($header) {
  if(!is_array($header)) {
    $header = webmail_plus_parse_header($header, TRUE);

  }

  if(sizeof($header)<=0) return FALSE;






  // FIXME this assumes that every message has a message-id
  $message_id = $header['message-id'];
  //echo "message_id: $message_id\n";
  $all_message_ids[$message_id] = $message_id;

  if($header['references']) {
    $references = explode(" ", $header['references']);
    foreach($references as $reference_id=>$reference) {
      $reference = trim($reference);
      //echo "refecence: $reference\n";
      if($reference=="") continue;
      $all_message_ids[$reference] = $reference;
    }
  }

  if($header['in-reply-to']) {
    $inreplyto = explode(" ", $header['in-reply-to']);
    foreach($inreplytos as $inreplyto_id=>$inreplyto) {
      $inreplyto = trim($inreplyto);
      if($inreplyto=="") continue;
      $all_message_ids[$inreplyto] = $inreplyto;
    }
  }

  return $all_message_ids;

}