<?php

/**
message subject should always be passed thru this function
since it ensures that if it's empty it still has some text
and thus will be clickable when turned into a link
*/
function webmail_plus_render_from($from="") {
   $from=trim($from);
   if(empty($from)) return t('(No from)');

   /*
   if(preg_match("/<(.*)>/", $from)) {
      drupal_set_message('matched brackes');
   }
   */

   if(preg_match("/(.*)<(.*)>/", $from)) {
      preg_match("/(.*)</", $from, $matches);
      $name = trim($matches[1]);
      return $name;
   }

   return $from;

}


/**
message subject should always be passed thru this function
since it ensures that if it's empty it still has some text
and thus will be clickable when turned into a link
*/
function webmail_plus_render_subject($subject="") {
   $subject=trim($subject);
   if(empty($subject)) return t('(No subject)');

   return $subject;

}

/**
date should always be passed thru this function
since it ensures that if it's empty it still has some text
and thus will be clickable when turned into a link

additionally it makes the date more presentable
*/
function webmail_plus_render_date($date="") {

   $date=trim($date);


   if(empty($date)) return t('(No date)');

   return date("m/d/Y h:i A", $date);
}